unit adxSTCustomRecognizer_IMPL;

interface

uses
  SysUtils, ComObj, ComServ, ActiveX, Variants, adxSmartTag, adxSmartTagTLB, adxSTCustomRecognizer_TLB, StdVcl,
  Classes;

type
  TADX_STCustomRecognizerRecognizer = class(TadxRecognizerObject, IADX_STCustomRecognizerRecognizer)
  protected
  end;

  TADX_STCustomRecognizerAction = class(TadxActionObject, IADX_STCustomRecognizerAction)
  protected
  end;

  TSmartTagModule = class(TadxSmartTagModule)
    adxSmartTag1: TadxSmartTag;
    procedure adxSmartTag1Recognize(Sender: TObject;
      const Text: WideString; DataType: TOleEnum; LocaleID: Integer;
      const CommitSmartTagProc: TadxCommitSmartTagProc; AppName: String;
      const TokenList: ISmartTagTokenList);
    procedure adxSmartTag1Actions0Click(Sender: TObject;
      const AppName: WideString; const Target: IDispatch; const Text,
      Xml: WideString; LocaleID: Integer);
  private
  protected
  public
  end;

implementation

{$R *.dfm}

uses Windows, ShellAPI, StrUtils;

const
  RecognizedWords: array [0..1] of string = ('Add-in', 'Add-in Express');

procedure TSmartTagModule.adxSmartTag1Recognize(Sender: TObject;
  const Text: WideString; DataType: TOleEnum; LocaleID: Integer;
  const CommitSmartTagProc: TadxCommitSmartTagProc; AppName: String;
  const TokenList: ISmartTagTokenList);
var
  i, Index: Integer;
  LocalText: string;
begin
  LocalText := LowerCase(Text);
  for i := Low(RecognizedWords) to High(RecognizedWords) do begin
    Index := Pos(LowerCase(RecognizedWords[i]), LocalText);
    while Index > 0 do begin
      CommitSmartTagProc(Index, Length(RecognizedWords[i]));
      Index := PosEx(LowerCase(RecognizedWords[i]), LocalText, Index + 1);
    end;
  end;
end;

procedure TSmartTagModule.adxSmartTag1Actions0Click(Sender: TObject;
  const AppName: WideString; const Target: IDispatch; const Text,
  Xml: WideString; LocaleID: Integer);
begin
  ShellExecute(0, 'open', 'mailto:support@add-in-express.com', '', '', SW_RESTORE);
end;

initialization
  TadxRecognizerFactory.Create(ComServer, TADX_STCustomRecognizerRecognizer,
    CLASS_ADX_STCustomRecognizerRecognizer, TSmartTagModule);

  TadxActionFactory.Create(ComServer, TADX_STCustomRecognizerAction,
    CLASS_ADX_STCustomRecognizerAction, TSmartTagModule);

end.
